# coding: utf-8

"""
Slices Experiment Authority

The Slices Experiment Authority API

The version of the OpenAPI document: 0.1.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from slices_expauth_client.models.resource_state import ResourceState
from typing import Optional, Set
from typing_extensions import Self


class ExperimentResource(BaseModel):
    """
    Experiment Resource info.
    """  # noqa: E501

    created_at: datetime = Field(description="Timestamp when this experiment was created")
    created_by: Optional[Annotated[str, Field(strict=True)]]
    description: Optional[Annotated[str, Field(min_length=3, strict=True, max_length=255)]]
    experiment_id: Annotated[str, Field(strict=True)] = Field(
        description="TypeID of an Experiment where this resource is a part of"
    )
    expires_at: Optional[datetime] = None
    friendly_name: Annotated[str, Field(strict=True)] = Field(description="User readable name")
    id: Annotated[str, Field(strict=True)] = Field(description="TypeID uniquely identifying a resource")
    project_id: Annotated[str, Field(strict=True)] = Field(description="TypeID of the project")
    service_id: StrictStr = Field(description="The ID of the service")
    site_id: StrictStr = Field(description="The ID of the site")
    status: ResourceState
    terminated_at: Optional[datetime]
    terminated_by: Optional[Annotated[str, Field(strict=True)]]
    type: StrictStr = Field(
        description='The type of resource. For BI Service Resources, this is "iot", "baremetal" or "vm".'
    )
    __properties: ClassVar[List[str]] = [
        "created_at",
        "created_by",
        "description",
        "experiment_id",
        "expires_at",
        "friendly_name",
        "id",
        "project_id",
        "service_id",
        "site_id",
        "status",
        "terminated_at",
        "terminated_by",
        "type",
    ]

    @field_validator("created_by")
    def created_by_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"user_[a-z][a-z0-9-.]{1,55}_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}", value):
            raise ValueError(
                r"must validate the regular expression /user_[a-z][a-z0-9-.]{1,55}_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}/"
            )
        return value

    @field_validator("experiment_id")
    def experiment_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"exp_[a-z0-9.-]*_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}", value):
            raise ValueError(
                r"must validate the regular expression /exp_[a-z0-9.-]*_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}/"
            )
        return value

    @field_validator("friendly_name")
    def friendly_name_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"[a-z0-9_-]{1,255}", value):
            raise ValueError(r"must validate the regular expression /[a-z0-9_-]{1,255}/")
        return value

    @field_validator("id")
    def id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"r_[a-z][a-z0-9-.]{1,55}_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}", value):
            raise ValueError(
                r"must validate the regular expression /r_[a-z][a-z0-9-.]{1,55}_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}/"
            )
        return value

    @field_validator("project_id")
    def project_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"proj_[a-z][a-z0-9-.]{1,55}_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}", value):
            raise ValueError(
                r"must validate the regular expression /proj_[a-z][a-z0-9-.]{1,55}_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}/"
            )
        return value

    @field_validator("terminated_by")
    def terminated_by_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"user_[a-z][a-z0-9-.]{1,55}_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}", value):
            raise ValueError(
                r"must validate the regular expression /user_[a-z][a-z0-9-.]{1,55}_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}/"
            )
        return value

    @field_validator("type")
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(["iot", "vm", "baremetal"]):
            raise ValueError("must be one of enum values ('iot', 'vm', 'baremetal')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ExperimentResource from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if created_by (nullable) is None
        # and model_fields_set contains the field
        if self.created_by is None and "created_by" in self.model_fields_set:
            _dict["created_by"] = None

        # set to None if description (nullable) is None
        # and model_fields_set contains the field
        if self.description is None and "description" in self.model_fields_set:
            _dict["description"] = None

        # set to None if expires_at (nullable) is None
        # and model_fields_set contains the field
        if self.expires_at is None and "expires_at" in self.model_fields_set:
            _dict["expires_at"] = None

        # set to None if terminated_at (nullable) is None
        # and model_fields_set contains the field
        if self.terminated_at is None and "terminated_at" in self.model_fields_set:
            _dict["terminated_at"] = None

        # set to None if terminated_by (nullable) is None
        # and model_fields_set contains the field
        if self.terminated_by is None and "terminated_by" in self.model_fields_set:
            _dict["terminated_by"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ExperimentResource from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "created_at": obj.get("created_at"),
                "created_by": obj.get("created_by"),
                "description": obj.get("description"),
                "experiment_id": obj.get("experiment_id"),
                "expires_at": obj.get("expires_at"),
                "friendly_name": obj.get("friendly_name"),
                "id": obj.get("id"),
                "project_id": obj.get("project_id"),
                "service_id": obj.get("service_id"),
                "site_id": obj.get("site_id"),
                "status": obj.get("status"),
                "terminated_at": obj.get("terminated_at"),
                "terminated_by": obj.get("terminated_by"),
                "type": obj.get("type"),
            }
        )
        return _obj
